#include "pcxload.h"

skin::skin() :height(0), width(0) {};

skin::~skin()
{
	delete[] skindata;
}

bool loadskin(std::ifstream &pcxfile, skin &modelskin)
{
	pcx_header head;

	pcxfile.read((char*)&head, sizeof(pcx_header));
	std::cout<<sizeof(pcx_header) << " bytes read" << std::endl;
	if (head.bpp != 8)
	{
		std::cout << "not an 8bit pcx file" << std::endl;
		return false;
	} 

	modelskin.width = (1 + head.xmax - head.xmin);
	modelskin.height = (1 + head.ymax - head.ymin);
	modelskin.skindata = new char[ (modelskin.width * modelskin.height) * 2 ];

	int32_t i = 0;
	
	while(i < (modelskin.width * modelskin.height) )
	{
		int8_t b[1];
		int32_t btop;
		int8_t c[1];
		pcxfile.read((char*)b,1);
		btop = *b & 0xC0;
		if(btop == 0xC0  ) //if both of the top two bits are set
		{
			pcxfile.read((char*)c,1); //read the next int8_t and repeat it the number of times in the 6 lower bits

			int32_t count;
			count = (*b & 0x3F);
			for(int32_t j = 0; j < count ; ++j)
			{
				modelskin.skindata[i] = *c;
				++i;
			}
		}
		else // just write that character
		{
				modelskin.skindata[i] = *b;
				++i;
		}
	}
	return true;
}
